import numpy as np
import sys
def filter_func(line):
    return not line.startswith('@') and not line.startswith('#')

def read_grofile(filename):
    grofile = []
    headline = []
    box_size =[]
    with open(filename, "r") as myfile:
        for _ in range(2):
            headline.append(myfile.readline())
        number_of_lines = int(headline[-1])
#        for row in myfile.readlines()[:-1]:
        for _ in range(number_of_lines):
            row = myfile.readline()
            resnumber = int(row[:5])
            resname = row[5:10].strip()
            name = row[10:15].strip()
            number = int(row[15:20])
            x = float(row[20:28])
            y = float(row[28:36])
            z = float(row[36:44])
            mid = {'resnumber': resnumber, 'resname': resname, 'name': name, 'number': number, 'x': x, 'y': y, 'z': z }
            grofile.append(mid)
        box_size.append(myfile.readline())
        return headline, grofile, box_size

def update_z(grofile, resname):
    temp = []
    for line in grofile:
        if line["resname"] == resname:
            temp.append(line)
    former_half = [z['z'] for z in temp[0:int(len(temp)/2)]]
    z_middle = sum(former_half)/int(len(temp)/2)
    for z in temp[0:int(len(temp)/2)]:
        z['z'] = z_middle

    latter_half = [z['z'] for z in temp[int(len(temp)/2):]]
    z_middle = sum(latter_half)/int(len(temp)/2)
    for z in temp[int(len(temp)/2):]:
        z['z'] = z_middle
def write_gro(filename, headline, content, boxsize):
    with open(filename,'w') as file:
        i=0
        for _ in content:
            i += 1
        file.writelines(headline[0])
        file.writelines("{0:>5}\n".format(i))
        for line in content:
            atom="{0:>5}{1:<5}{2:>5}{3:>5}{4:>8.3f}{5:>8.3f}{6:>8.3f}\n".format(line['resnumber'], line['resname'], line['name'], line['number'], line['x'], line['y'], line['z'])
            for item in atom:
                file.write(item)
        for size_item in boxsize:
            file.write(size_item)
        file.close()


def read_file(filename0):


    headline, grofile, box_size = read_grofile(filename0)
    update_z(grofile, "TIP3")

    temp = []
    for line in grofile:
        if line["resname"] == "TIP3":
            temp.append(line)
    former_half = [z['z'] for z in temp]
    z_middle = sum(former_half)/len(temp)
    for z in temp:
        z['z'] = z_middle


    temp = []
    for line in grofile:
        if line["resname"] == "W":
            temp.append(line)
    for z in temp:
        z['z'] = 0



    write_gro(input_file_add + input_file_name2, headline, grofile, box_size)

input_file_add = sys.argv[1]
input_file_name1 = "/"+sys.argv[2]
input_file_name2 = "/"+sys.argv[3]
read_file(input_file_add + input_file_name1)

